package net.psammead.mwapi.yurik;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

// could use javax.xml.datatype.XMLGregorianCalendar

public final class IsoDateConverter {
	public static final TimeZone	GMT_ZONE	= TimeZone.getTimeZone("GMT");
	public static final DateFormat	ISO_8601	= new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
	static { ISO_8601.setTimeZone(GMT_ZONE); }
	
	private IsoDateConverter() {}

	/** parse a timestamp in ISO 8601 format */
	public static Date parseTimestamp(String s) throws ParseException {
		return ISO_8601.parse(s);
	}
	
	public static String formatTimestamp(Date d) {
		return ISO_8601.format(d);
	}
}
